#include <basedef.h>
#include <VXDWRAPS.H>
#include <vmm.h>
#include <minivdd.H>
#include <shell.h>

#include <ifs.h>

#include <vwin32.h>

#include "vmmwrap2.h"
#include "files.h"
pIFSFileHookFunc oldHook=NULL;
char path[270];
int hookedDrive=0;
fh_t lastFakedSearch=0;
FS_FileAttributes(pioreq pir){
  char tempPath[270];
  int i;
 // SimpleMessage("attrib");
  UniToBCSPathDrive(tempPath,pir->ir_ppath,256,BCS_WANSI,hookedDrive);
 // SimpleMessage(tempPath);

  switch(pir->ir_flags){
    case GET_ATTRIBUTES: 
    case GET_ATTRIB_COMP_FILESIZE: 
      for (i=0;(i<255)&&(path[i]!='\0')&&(tempPath[i]!='\0');i++)
        if (path[i]!=tempPath[i]) 
          if (((path[i]>='a')&&(path[i]<='z'))||((tempPath[i]>='a')&&(tempPath[i]<='z')))
            if ((((path[i]+('a'-'A'))!=tempPath[i]))&&(path[i]!=(tempPath[i]+('a'-'A')))) return pir->ir_error;
      pir->ir_size=2000000000;
  }  
  //SimpleMessage("ok");
  return pir->ir_error;
}
FS_FindFirstFile(pioreq pir){
  char tempPath[270];
  int i;
 // SimpleMessage("findFirst");
  UniToBCSPathDrive(tempPath,pir->ir_ppath,256,BCS_WANSI,hookedDrive);
  //SimpleMessage(tempPath);
  for (i=0;(i<255)&&(path[i]!='\0')&&(tempPath[i]!='\0');i++)
    if (path[i]!=tempPath[i]) 
      if (((path[i]>='a')&&(path[i]<='z'))||((tempPath[i]>='a')&&(tempPath[i]<='z')))
        if ((((path[i]+('a'-'A'))!=tempPath[i]))&&(path[i]!=(tempPath[i]+('a'-'A')))) return pir->ir_error;
 // SimpleMessage("ok path");
  ((_WIN32_FIND_DATA*)pir->ir_data)->nFileSizeLow =2000000000;
  ((_WIN32_FIND_DATA*)pir->ir_data)->nFileSizeHigh =2000000000;
  lastFakedSearch= pir->ir_fh;
 // SimpleMessage(((_WIN32_FIND_DATA*)pir->ir_data)->cFileName);
  return pir->ir_error;
}
FS_FindNextFile(pioreq pir){
  if (pir->ir_fh==lastFakedSearch) {
    ((_WIN32_FIND_DATA*)pir->ir_data)->nFileSizeLow =2000000000;
    ((_WIN32_FIND_DATA*)pir->ir_data)->nFileSizeHigh =2000000000;
  }
  return pir->ir_error;
}
FileSystemApiHookFunction(pIFSFunc FSDFnAddr, int FunctionNum, int Drive, int ResourceFlags, int CodePage, pioreq pir)
{ 
  if (Drive==hookedDrive) {
    switch (FunctionNum) {
      case IFSFN_FILEATTRIB://SimpleMessage("do");
        switch (pir->ir_flags) {
          case GET_ATTRIBUTES: 
          case GET_ATTRIB_COMP_FILESIZE: 
            oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
            return FS_FileAttributes(pir);
        }
        break;
      case IFSFN_FINDOPEN://SimpleMessage("do");
        oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
        return FS_FindFirstFile(pir);
        break;
      case IFSFN_FINDNEXT://SimpleMessage("do");
        oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
        return FS_FindNextFile(pir);
        break;
    }
  }
  return oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
}
extern int __stdcall _CIoControl(DIOCPARAMETERS * deviceControl){
  switch (deviceControl->dwIoControlCode) {
     case 1:  //Mainfunction One, hook one Drive
        if (deviceControl->cbInBuffer!=256) {
          showMessage(MB_OK | MB_SYSTEMMODAL | MB_ICONEXCLAMATION | MB_ASAP,"Invalid Buffersize, must be 256 (test 1)","File Size Simulator");
          return 1;
        }
        if (oldHook!=0) return 2;
        cpyStrN(&path[0],(char*)(deviceControl->lpvInBuffer),256);
        path[255]='\0';
        hookedDrive=path[0]-'A'+1;
        //SimpleMessage(path);
        oldHook=IFSMgr_InstallFileSystemApiHookCWrap(&FileSystemApiHookFunction);
        break;
     case DIOC_OPEN: 
      //load vxd
      break;
    case DIOC_CLOSEHANDLE:  
      if (oldHook!=NULL) 
        IFSMgr_RemoveFileSystemApiHookCWrap(&FileSystemApiHookFunction);
      oldHook=NULL;
      //close vxd
      break;
  }
  return 0;
}
